Summary: %{label}
Name: update-%{label}
Version: %{version}
Release: 1
License: Proprietary
%{lua: f = io.open(rpm.expand("%{_topdir}").."/source0") if f ~= nil then print(f:read "*a") f:close() end }

Provides: %{uuid}
%{lua: f = io.open(rpm.expand("%{_topdir}").."/requires") print(f:read "*a") f:close() }
%{lua: f = io.open(rpm.expand("%{_topdir}").."/obsoletes") if f ~= nil then print(f:read "*a") f:close() end }
%{lua: f = io.open(rpm.expand("%{_topdir}").."/provides") if f ~= nil then print(f:read "*a") f:close() end }

BuildArch: noarch

%description
%{lua: f = io.open(rpm.expand("%{_topdir}").."/description") print(f:read "*a") f:close() }

%define update_dir %{_var}/update

%{lua: f = io.open(rpm.expand("%{_topdir}").."/prep_install") if f ~= nil then print(f:read "*a") f:close() end }

%pretrans -p <lua>
os.execute('find /run/reboot-required.d -type f -exec stat -c "%n %y" {} \\; > /run/reboot-required.%{uuid}.tmp 2> /dev/null')

%posttrans
%if 0%{?build_number:1}
if [ -f %{_sysconfdir}/xensource-inventory ]; then
    sed -i -e "s@^\(BUILD_NUMBER=\).*@\1'%{build_number}'@" %{_sysconfdir}/xensource-inventory
fi
%endif

mkdir -p %{update_dir}/applied
cat >%{update_dir}/applied/%{uuid} <<EOF
%{lua: f = io.open(rpm.expand("%{_topdir}").."/stampfile.xml") print(f:read "*a") f:close() }
EOF

%{lua: f = io.open(rpm.expand("%{_topdir}").."/posttrans") if f ~= nil then print(f:read "*a") f:close() end }
find /run/reboot-required.d -type f -exec stat -c '%n %y' {} \; > /run/reboot-required.%{uuid}.tmp2 2> /dev/null

if ! cmp -s /run/reboot-required.%{uuid}.tmp{,2}; then
    echo "%{uuid}" >> /run/reboot-required.hfxs
fi

rm -f /run/reboot-required.%{uuid}.tmp{,2}

# remove any updates that were created after this
for sfile in %{update_dir}/applied/*; do
    follows=$(xmllint --xpath "string(//update/follows/@name-label)" $sfile)
    if [ "$follows" = %{label} ]; then
        rm -f $sfile
    fi
done
exit 0

%postun
if [ $1 -eq 0 ]; then
    if [ -e %{update_dir}/%{uuid}/.remove ]; then
        rm -f %{update_dir}/applied/%{uuid}
    fi

    if [ -e %{update_dir}/applied/%{uuid} -a \
        -z "`xmllint --xpath \"string(//update/rolled-up-by/@uuid)\" %{update_dir}/applied/%{uuid}`" ]; then
            rm -f %{update_dir}/applied/%{uuid}
    fi
fi

%files
%{lua: f = io.open(rpm.expand("%{_topdir}").."/provides") if f~= nil then print(rpm.expand("%{update_dir}").."/applied/*") f:close() end }
